#ifndef GITCONFIG_H
#define GITCONFIG_H
// generated from class_header.h
#include <nan.h>
#include <string>

extern "C" {
#include <git2.h>
}

#include "../include/config.h"
// Forward declaration.
struct git_config {
};

using namespace node;
using namespace v8;

class GitConfig : public ObjectWrap {
public:

  static Persistent<Function> constructor_template;
  static void InitializeComponent (Handle<v8::Object> target);

  git_config *GetValue();
  git_config **GetRefValue();
  void ClearValue();

  static Handle<v8::Value> New(void *raw, bool selfFreeing);
  bool selfFreeing;



private:


  GitConfig(git_config *raw, bool selfFreeing);
  ~GitConfig();

  static NAN_METHOD(JSNewFunction);


  struct GetStringBaton {
    int error_code;
    const git_error* error;
    const char * out;
    const git_config * cfg;
    const char * name;
  };
  class GetStringWorker : public NanAsyncWorker {
  public:
    GetStringWorker(
      GetStringBaton *_baton,
      NanCallback *callback
    ) : NanAsyncWorker(callback)
      , baton(_baton) {};
    ~GetStringWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    GetStringBaton *baton;
  };

  static NAN_METHOD(GetString);

  struct OpenDefaultBaton {
    int error_code;
    const git_error* error;
    git_config * out;
  };
  class OpenDefaultWorker : public NanAsyncWorker {
  public:
    OpenDefaultWorker(
      OpenDefaultBaton *_baton,
      NanCallback *callback
    ) : NanAsyncWorker(callback)
      , baton(_baton) {};
    ~OpenDefaultWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    OpenDefaultBaton *baton;
  };

  static NAN_METHOD(OpenDefault);

  static NAN_METHOD(SetInt64);

  static NAN_METHOD(SetMultivar);

  struct SetStringBaton {
    int error_code;
    const git_error* error;
    git_config * cfg;
    const char * name;
    const char * value;
  };
  class SetStringWorker : public NanAsyncWorker {
  public:
    SetStringWorker(
      SetStringBaton *_baton,
      NanCallback *callback
    ) : NanAsyncWorker(callback)
      , baton(_baton) {};
    ~SetStringWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    SetStringBaton *baton;
  };

  static NAN_METHOD(SetString);

  struct SnapshotBaton {
    int error_code;
    const git_error* error;
    git_config * out;
    git_config * config;
  };
  class SnapshotWorker : public NanAsyncWorker {
  public:
    SnapshotWorker(
      SnapshotBaton *_baton,
      NanCallback *callback
    ) : NanAsyncWorker(callback)
      , baton(_baton) {};
    ~SnapshotWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    SnapshotBaton *baton;
  };

  static NAN_METHOD(Snapshot);
  git_config *raw;
};

#endif
