#ifndef GITSTASH_H
#define GITSTASH_H
// generated from class_header.h
#include <nan.h>
#include <string>

extern "C" {
#include <git2.h>
}

#include "../include/repository.h"
#include "../include/oid.h"
#include "../include/signature.h"

using namespace node;
using namespace v8;

class GitStash : public ObjectWrap {
public:

  static Persistent<Function> constructor_template;
  static void InitializeComponent (Handle<v8::Object> target);

  bool selfFreeing;

  static int Foreach_callback_cppCallback (
    size_t index
    ,
    const char * message
    ,
    const git_oid * stash_id
    ,
    void * payload
  );

  static void Foreach_callback_async(uv_async_t* req, int status);
  static void Foreach_callback_asyncPromisePolling(uv_async_t* req, int status);
  struct Foreach_CallbackBaton {
    size_t index;
    const char * message;
    const git_oid * stash_id;
    void * payload;

    uv_async_t req;
    int result;
    Persistent<Object> promise;
    bool done;
  };


private:



  static NAN_METHOD(JSNewFunction);


  static NAN_METHOD(Drop);

  struct ForeachBaton {
    int error_code;
    const git_error* error;
    git_repository * repo;
    git_stash_cb callback;
    void * payload;
  };
  class ForeachWorker : public NanAsyncWorker {
  public:
    ForeachWorker(
      ForeachBaton *_baton,
      NanCallback *callback
    ) : NanAsyncWorker(callback)
      , baton(_baton) {};
    ~ForeachWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    ForeachBaton *baton;
  };

  static NAN_METHOD(Foreach);

  struct SaveBaton {
    int error_code;
    const git_error* error;
    git_oid * out;
    git_repository * repo;
    const git_signature * stasher;
    const char * message;
    unsigned int flags;
  };
  class SaveWorker : public NanAsyncWorker {
  public:
    SaveWorker(
      SaveBaton *_baton,
      NanCallback *callback
    ) : NanAsyncWorker(callback)
      , baton(_baton) {};
    ~SaveWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    SaveBaton *baton;
  };

  static NAN_METHOD(Save);

  struct Foreach_globalPayload {
    NanCallback * callback;

    Foreach_globalPayload() {
      callback = NULL;
    }

    ~Foreach_globalPayload() {
      if (callback != NULL) {
        delete callback;
      }
    }
  };
};

#endif
