// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/cert.h"


#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitCert::GitCert(git_cert *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitCert::~GitCert()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitCert::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("Cert"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "certType", CertType);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("Cert"), _constructor_template);
}

NAN_METHOD(GitCert::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitCert cannot be instantiated.");
  }

  GitCert* object = new GitCert(static_cast<git_cert *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitCert::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitCert::constructor_template)->NewInstance(2, argv));
}

git_cert *GitCert::GetValue()
{
  return this->raw;
}

git_cert **GitCert::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitCert::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitCert::CertType)
{
  NanScope();
  Handle<v8::Value> to;

  git_cert_t
  cert_type =
    ObjectWrap::Unwrap<GitCert>(args.This())->GetValue()->cert_type;
// start convert_to_v8 block
  to = NanNew<Number>( cert_type);
  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitCert::constructor_template;
