// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/cert_x509.h"

#include "../include/wrapper.h"
#include "node_buffer.h"

#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitCertX509::GitCertX509(git_cert_x509 *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitCertX509::~GitCertX509()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitCertX509::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("CertX509"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "certType", CertType);
  NODE_SET_PROTOTYPE_METHOD(tpl, "data", Data);
  NODE_SET_PROTOTYPE_METHOD(tpl, "len", Len);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("CertX509"), _constructor_template);
}

NAN_METHOD(GitCertX509::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitCertX509 cannot be instantiated.");
  }

  GitCertX509* object = new GitCertX509(static_cast<git_cert_x509 *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitCertX509::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitCertX509::constructor_template)->NewInstance(2, argv));
}

git_cert_x509 *GitCertX509::GetValue()
{
  return this->raw;
}

git_cert_x509 **GitCertX509::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitCertX509::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitCertX509::CertType)
{
  NanScope();
  Handle<v8::Value> to;

  git_cert_t
  cert_type =
    ObjectWrap::Unwrap<GitCertX509>(args.This())->GetValue()->cert_type;
// start convert_to_v8 block
  to = NanNew<Number>( cert_type);
  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitCertX509::Data)
{
  NanScope();
  Handle<v8::Value> to;

  void *
  data =
    ObjectWrap::Unwrap<GitCertX509>(args.This())->GetValue()->data;
// start convert_to_v8 block

  if (data != NULL) {
    // Wrapper data
    to = Wrapper::New((void *)data);
  } else {
    to = NanNull();
  }

// end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitCertX509::Len)
{
  NanScope();
  Handle<v8::Value> to;

  size_t
  len =
    ObjectWrap::Unwrap<GitCertX509>(args.This())->GetValue()->len;
// start convert_to_v8 block
  to = NanNew<Number>( len);
  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitCertX509::constructor_template;
