// This is a generated file, modify: generate/templates/struct_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include <iostream>
#include "../include/functions/copy.h"
#include "../include/diff_find_options.h"


using namespace v8;
using namespace node;
using namespace std;


// generated from struct_content.cc
GitDiffFindOptions::GitDiffFindOptions()
{
  git_diff_find_options wrappedValue = GIT_DIFF_FIND_OPTIONS_INIT;
  this->raw = (git_diff_find_options*) malloc(sizeof(git_diff_find_options));
  memcpy(this->raw, &wrappedValue, sizeof(git_diff_find_options));

  this->ConstructFields();
  this->selfFreeing = true;
}

GitDiffFindOptions::GitDiffFindOptions(git_diff_find_options* raw, bool selfFreeing)
{
  this->raw = raw;
  this->ConstructFields();
  this->selfFreeing = selfFreeing;
}

GitDiffFindOptions::~GitDiffFindOptions()
{

  if (this->selfFreeing) {
    free(this->raw);
  }
}

void GitDiffFindOptions::ConstructFields()
{
}

void GitDiffFindOptions::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("DiffFindOptions"));

  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("version"), GetVersion, SetVersion);
  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("flags"), GetFlags, SetFlags);
  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("renameThreshold"), GetRenameThreshold, SetRenameThreshold);
  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("renameFromRewriteThreshold"), GetRenameFromRewriteThreshold, SetRenameFromRewriteThreshold);
  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("copyThreshold"), GetCopyThreshold, SetCopyThreshold);
  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("breakRewriteThreshold"), GetBreakRewriteThreshold, SetBreakRewriteThreshold);
  tpl->InstanceTemplate()->SetAccessor(NanNew<String>("renameLimit"), GetRenameLimit, SetRenameLimit);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("DiffFindOptions"), _constructor_template);
}

NAN_METHOD(GitDiffFindOptions::JSNewFunction)
{
  NanScope();
  GitDiffFindOptions* instance;

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    instance = new GitDiffFindOptions();
  } else {
    instance = new GitDiffFindOptions(static_cast<git_diff_find_options*>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  }

  instance->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitDiffFindOptions::New(void* raw, bool selfFreeing)
{
  NanEscapableScope();

  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitDiffFindOptions::constructor_template)->NewInstance(2, argv));
}

git_diff_find_options *GitDiffFindOptions::GetValue()
{
  return this->raw;
}

git_diff_find_options **GitDiffFindOptions::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitDiffFindOptions::ClearValue()
{
  this->raw = NULL;
}

NAN_GETTER(GitDiffFindOptions::GetVersion)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->version));
}

NAN_SETTER(GitDiffFindOptions::SetVersion)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->version = (unsigned int) value->Int32Value();
  }
}

NAN_GETTER(GitDiffFindOptions::GetFlags)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->flags));
}

NAN_SETTER(GitDiffFindOptions::SetFlags)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->flags = (uint32_t) value->Int32Value();
  }
}

NAN_GETTER(GitDiffFindOptions::GetRenameThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->rename_threshold));
}

NAN_SETTER(GitDiffFindOptions::SetRenameThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->rename_threshold = (uint16_t) value->Int32Value();
  }
}

NAN_GETTER(GitDiffFindOptions::GetRenameFromRewriteThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->rename_from_rewrite_threshold));
}

NAN_SETTER(GitDiffFindOptions::SetRenameFromRewriteThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->rename_from_rewrite_threshold = (uint16_t) value->Int32Value();
  }
}

NAN_GETTER(GitDiffFindOptions::GetCopyThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->copy_threshold));
}

NAN_SETTER(GitDiffFindOptions::SetCopyThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->copy_threshold = (uint16_t) value->Int32Value();
  }
}

NAN_GETTER(GitDiffFindOptions::GetBreakRewriteThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->break_rewrite_threshold));
}

NAN_SETTER(GitDiffFindOptions::SetBreakRewriteThreshold)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->break_rewrite_threshold = (uint16_t) value->Int32Value();
  }
}

NAN_GETTER(GitDiffFindOptions::GetRenameLimit)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  NanReturnValue(NanNew<Number>(wrapper->GetValue()->rename_limit));
}

NAN_SETTER(GitDiffFindOptions::SetRenameLimit)
{
  NanScope();

  GitDiffFindOptions *wrapper = ObjectWrap::Unwrap<GitDiffFindOptions>(args.This());

  if (value->IsNumber()) {
    wrapper->GetValue()->rename_limit = (size_t) value->Int32Value();
  }
}


Persistent<Function> GitDiffFindOptions::constructor_template;
