// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/rebase_operation.h"

#include "../include/oid.h"

#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitRebaseOperation::GitRebaseOperation(git_rebase_operation *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitRebaseOperation::~GitRebaseOperation()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitRebaseOperation::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("RebaseOperation"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "type", Type);
  NODE_SET_PROTOTYPE_METHOD(tpl, "id", Id);
  NODE_SET_PROTOTYPE_METHOD(tpl, "exec", Exec);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("RebaseOperation"), _constructor_template);
}

NAN_METHOD(GitRebaseOperation::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitRebaseOperation cannot be instantiated.");
  }

  GitRebaseOperation* object = new GitRebaseOperation(static_cast<git_rebase_operation *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitRebaseOperation::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitRebaseOperation::constructor_template)->NewInstance(2, argv));
}

git_rebase_operation *GitRebaseOperation::GetValue()
{
  return this->raw;
}

git_rebase_operation **GitRebaseOperation::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitRebaseOperation::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitRebaseOperation::Type)
{
  NanScope();
  Handle<v8::Value> to;

  git_rebase_operation_t
  type =
    ObjectWrap::Unwrap<GitRebaseOperation>(args.This())->GetValue()->type;
// start convert_to_v8 block
  to = NanNew<Number>( type);
  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitRebaseOperation::Id)
{
  NanScope();
  Handle<v8::Value> to;

  const git_oid
  *
  id =
    &
    ObjectWrap::Unwrap<GitRebaseOperation>(args.This())->GetValue()->id;
// start convert_to_v8 block

  if (id != NULL) {
    // GitOid id
    to = GitOid::New((void *)id, false);
  } else {
    to = NanNull();
  }

// end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitRebaseOperation::Exec)
{
  NanScope();
  Handle<v8::Value> to;

  const char *
  exec =
    ObjectWrap::Unwrap<GitRebaseOperation>(args.This())->GetValue()->exec;
// start convert_to_v8 block
  if (exec) {
    to = NanNew<String>(exec);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitRebaseOperation::constructor_template;
